/* pseudoGeneLink.c was originally generated by the autoSql program, which also 
 * generated pseudoGeneLink.h and pseudoGeneLink.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "pseudoGeneLink.h"

static char const rcsid[] = "$Id: pseudoGeneLink.c,v 1.4 2003/09/19 18:46:07 baertsch Exp $";

void pseudoGeneLinkStaticLoad(char **row, struct pseudoGeneLink *ret)
/* Load a row from pseudoGeneLink table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->name = row[0];
ret->score = sqlUnsigned(row[1]);
ret->assembly = row[2];
ret->geneTable = row[3];
ret->gene = row[4];
ret->chrom = row[5];
ret->gStart = sqlUnsigned(row[6]);
ret->gEnd = sqlUnsigned(row[7]);
ret->score2 = sqlUnsigned(row[8]);
ret->score3 = sqlUnsigned(row[9]);
ret->chainId = sqlUnsigned(row[10]);
ret->strand = row[11];
ret->polyA = sqlUnsigned(row[12]);
ret->polyAstart = sqlUnsigned(row[13]);
ret->pchrom = row[14];
ret->pStart = sqlUnsigned(row[15]);
ret->pEnd = sqlUnsigned(row[16]);
ret->pStrand = row[17];
}

struct pseudoGeneLink *pseudoGeneLinkLoad(char **row)
/* Load a pseudoGeneLink from row fetched with select * from pseudoGeneLink
 * from database.  Dispose of this with pseudoGeneLinkFree(). */
{
struct pseudoGeneLink *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->name = cloneString(row[0]);
ret->score = sqlUnsigned(row[1]);
ret->assembly = cloneString(row[2]);
ret->geneTable = cloneString(row[3]);
ret->gene = cloneString(row[4]);
ret->chrom = cloneString(row[5]);
ret->gStart = sqlUnsigned(row[6]);
ret->gEnd = sqlUnsigned(row[7]);
ret->score2 = sqlUnsigned(row[8]);
ret->score3 = sqlUnsigned(row[9]);
ret->chainId = sqlUnsigned(row[10]);
ret->strand = cloneString(row[11]);
ret->polyA = sqlUnsigned(row[12]);
ret->polyAstart = sqlUnsigned(row[13]);
ret->pchrom = cloneString(row[14]);
ret->pStart = sqlUnsigned(row[15]);
ret->pEnd = sqlUnsigned(row[16]);
ret->pStrand = cloneString(row[17]);
return ret;
}

struct pseudoGeneLink *pseudoGeneLinkLoadAll(char *fileName) 
/* Load all pseudoGeneLink from a whitespace-separated file.
 * Dispose of this with pseudoGeneLinkFreeList(). */
{
struct pseudoGeneLink *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[18];

while (lineFileRow(lf, row))
    {
    el = pseudoGeneLinkLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct pseudoGeneLink *pseudoGeneLinkLoadAllByChar(char *fileName, char chopper) 
/* Load all pseudoGeneLink from a chopper separated file.
 * Dispose of this with pseudoGeneLinkFreeList(). */
{
struct pseudoGeneLink *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[18];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = pseudoGeneLinkLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct pseudoGeneLink *pseudoGeneLinkCommaIn(char **pS, struct pseudoGeneLink *ret)
/* Create a pseudoGeneLink out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new pseudoGeneLink */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->name = sqlStringComma(&s);
ret->score = sqlUnsignedComma(&s);
ret->assembly = sqlStringComma(&s);
ret->geneTable = sqlStringComma(&s);
ret->gene = sqlStringComma(&s);
ret->chrom = sqlStringComma(&s);
ret->gStart = sqlUnsignedComma(&s);
ret->gEnd = sqlUnsignedComma(&s);
ret->score2 = sqlUnsignedComma(&s);
ret->score3 = sqlUnsignedComma(&s);
ret->chainId = sqlUnsignedComma(&s);
ret->strand = sqlStringComma(&s);
ret->polyA = sqlUnsignedComma(&s);
ret->polyAstart = sqlUnsignedComma(&s);
ret->pchrom = sqlStringComma(&s);
ret->pStart = sqlUnsignedComma(&s);
ret->pEnd = sqlUnsignedComma(&s);
ret->pStrand = sqlStringComma(&s);
*pS = s;
return ret;
}

void pseudoGeneLinkFree(struct pseudoGeneLink **pEl)
/* Free a single dynamically allocated pseudoGeneLink such as created
 * with pseudoGeneLinkLoad(). */
{
struct pseudoGeneLink *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->assembly);
freeMem(el->geneTable);
freeMem(el->gene);
freeMem(el->chrom);
freeMem(el->strand);
freeMem(el->pchrom);
freeMem(el->pStrand);
freez(pEl);
}

void pseudoGeneLinkFreeList(struct pseudoGeneLink **pList)
/* Free a list of dynamically allocated pseudoGeneLink's */
{
struct pseudoGeneLink *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    pseudoGeneLinkFree(&el);
    }
*pList = NULL;
}

void pseudoGeneLinkOutput(struct pseudoGeneLink *el, FILE *f, char sep, char lastSep) 
/* Print out pseudoGeneLink.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->score);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->assembly);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->geneTable);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->gene);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->gStart);
fputc(sep,f);
fprintf(f, "%u", el->gEnd);
fputc(sep,f);
fprintf(f, "%u", el->score2);
fputc(sep,f);
fprintf(f, "%u", el->score3);
fputc(sep,f);
fprintf(f, "%u", el->chainId);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->polyA);
fputc(sep,f);
fprintf(f, "%u", el->polyAstart);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->pchrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->pStart);
fputc(sep,f);
fprintf(f, "%u", el->pEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->pStrand);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

