# wiggle.sql was originally generated by the autoSql program, which also 
# generated wiggle.c and wiggle.h.  This creates the database representation of
# an object which can be loaded and saved from RAM in a fairly 
# automatic way.

#Wiggle track values to display as y-values (first 6 fields are bed6)
CREATE TABLE wiggle (
    chrom varchar(255) not null,	# Human chromosome or FPC contig
    chromStart int unsigned not null,	# Start position in chromosome
    chromEnd int unsigned not null,	# End position in chromosome
    name varchar(255) not null,	# Name of item
    score int unsigned not null,	# range [0:127] == maximum in this block
    strand char(1) not null,	# + or - (may not be needed for wiggle)
    Min int unsigned not null,	# range [0:126] == minimum in this block
    Span int unsigned not null,	# each value spans this many bases
    Count int unsigned not null,	# number of values in this block
    Offset int unsigned not null,	# offset in File to fetch data
    File varchar(255) not null,	# path name to data file, one byte per value
    lowerLimit double not null,	# lowest data value in this block
    dataRange double not null,	# lowerLimit + dataRange = upperLimit
    validCount int unsigned not null,	# number of valid data values in this block
    average double not null,	# average of the data valeus, we may need this later
    stddev double not null,	# standard deviation, we may need this later
              #Indices
    PRIMARY KEY(chrom)
);
